#version 120
//
// pass2.frag
//
#define MAXSAMPLES 256                  // Tv_̍ő吔
#define JITTERING 0                     // jittering ̗L

const int SAMPLES = 256;                // Tv_
const float SAMPLING_RATIO = 2.0;       // Tv_̐̔rW

uniform sampler2D unit[7];              // eNX`jbg
uniform vec4 point[MAXSAMPLES];         // Tv_̈ʒu
uniform vec4 reflection;                // f荞݂̔˗
uniform float refraction;               // ܗ
uniform float bgdistance;               // wiƂ̋
varying vec2 texcoord;                  // eNX`W

void main(void)
{
  // unit[0] gUˌx diffuse + specular 擾
  vec4 diffspec = texture2D(unit[0], texcoord);
  
  // diffspec ̃At@l 0 Ȃwi (unit[6]) ̂
  if (diffspec.a == 0.0) {
    gl_FragColor = texture2D(unit[6], texcoord);
    return;
  }
  
  // unit[2] 珈Ώۂ̉f̎_Wn̈ʒu position 擾
  vec4 p = texture2D(unit[2], texcoord);

  // ՕȂ|Cg̐
  int count = 0;
  
#if JITTERING
  // Wb^O
  int offset = int(mod(gl_FragCoord.y, 4.0)) * 64 + int(mod(gl_FragCoord.x, 4.0)) * 16;
#endif
  
  // X̃Tv_ɂ
  for (int i = 0; i < SAMPLES; ++i) {

    // Tv_̈ʒu p ̑ΈʒuɕsړC̓_̃NbsOWn̈ʒu q ߂
#if JITTERING
    vec4 q = gl_ProjectionMatrix * (p + point[i + offset]);
#else
    vec4 q = gl_ProjectionMatrix * (p + point[i]);
#endif
    
    // eNX`Wɕϊ
    q = q * 0.5 / q.w + 0.5;
      
    // q ̐[x unit[4] ̒l (fvXobt@̒l) 菬΁CՕȂ|CgƂăJEg
    if (q.z < texture2D(unit[4], q.xy).z) ++count;
  }

  // ՕȂ|Cg̐ՕW߂
  float a = clamp(float(count) * SAMPLING_RATIO / float(SAMPLES), 0.0, 1.0);
  
  // ̔ˌ (unit[1]) ɊՕWKp
  vec4 color = diffspec + texture2D(unit[1], texcoord) * a;
  
  // unit[3] @xNgo
  vec3 normal = texture2D(unit[3], texcoord).xyz;

  //  (˃}bsO)
  color += texture2D(unit[5], normal.xy * 0.5 + 0.5) * reflection;
  
  // wi (܃}bsO)
  vec4 bg = texture2D(unit[6], texcoord + refract(vec3(0.0, 0.0, 1.0), normal, refraction).xy * bgdistance);

  // SiƔwiďo
  gl_FragColor = mix(bg, color, color.a);
}
